import '@s-ui/segment-wrapper'
import domain from '../domainFactory'
import clickListener from './clickListener'
import {setupSegmentWrapperConfig, getVisitorId} from './segmentWrapper'
import {syncDmpIds} from './adobe'
import trackByWindowObject from './trackByWindowObject'

const loader = async () => {
  setupSegmentWrapperConfig()
  window.rubik = window.rubik || {}
  await getVisitorId()
  // we keep this fn for legacy reasons, we are not sure but in case someone
  // is calling window.rubik.analytics.track directly it will still work
  window.rubik.analytics = {
    track: (event, properties, options) => {
      console.log('Calling the track function with event: ', event)
      console.table(properties)
      console.table(options)
      domain.get('track_tracking_use_case').execute({
        event,
        properties,
        options
      })
    }
  }
  syncDmpIds(domain)
  clickListener(domain)
  console.log('Just before the trackByWindowObject function!')
  trackByWindowObject()
}

export default loader
